diff a/src/hotspot/share/memory/classLoaderMetaspace.cpp b/src/hotspot/share/memory/classLoaderMetaspace.cpp
--- a/src/hotspot/share/memory/classLoaderMetaspace.cpp
+++ b/src/hotspot/share/memory/classLoaderMetaspace.cpp
@@ -28,53 +28,64 @@
 #include "memory/classLoaderMetaspace.hpp"
 #include "memory/metaspace.hpp"
 #include "memory/metaspaceUtils.hpp"
 #include "memory/metaspace/chunkManager.hpp"
 #include "memory/metaspace/internalStats.hpp"
+#include "memory/metaspace/metablock.hpp"
 #include "memory/metaspace/metaspaceArena.hpp"
 #include "memory/metaspace/metaspaceArenaGrowthPolicy.hpp"
+#include "memory/metaspace/metaspaceCommon.hpp"
+#include "memory/metaspace/metaspaceContext.hpp"
 #include "memory/metaspace/metaspaceSettings.hpp"
 #include "memory/metaspace/metaspaceStatistics.hpp"
 #include "memory/metaspace/runningCounters.hpp"
 #include "memory/metaspaceTracer.hpp"
+#include "oops/klass.hpp"
 #include "runtime/mutexLocker.hpp"
 #include "utilities/debug.hpp"
 
 using metaspace::ChunkManager;
+using metaspace::MetaBlock;
 using metaspace::MetaspaceArena;
+using metaspace::MetaspaceContext;
 using metaspace::ArenaGrowthPolicy;
 using metaspace::RunningCounters;
 using metaspace::InternalStats;
 
 #define LOGFMT         "CLMS @" PTR_FORMAT " "
 #define LOGFMT_ARGS    p2i(this)
 
 ClassLoaderMetaspace::ClassLoaderMetaspace(Mutex* lock, Metaspace::MetaspaceType space_type) :
+    ClassLoaderMetaspace(lock, space_type,
+                         MetaspaceContext::context_nonclass(),
+                         MetaspaceContext::context_class(),
+                         CompressedKlassPointers::klass_alignment_in_words())
+{}
+
+ClassLoaderMetaspace::ClassLoaderMetaspace(Mutex* lock, Metaspace::MetaspaceType space_type,
+                                           MetaspaceContext* non_class_context,
+                                           MetaspaceContext* class_context,
+                                           size_t klass_alignment_words) :
   _lock(lock),
   _space_type(space_type),
   _non_class_space_arena(nullptr),
   _class_space_arena(nullptr)
 {
-  ChunkManager* const non_class_cm =
-          ChunkManager::chunkmanager_nonclass();
-
   // Initialize non-class Arena
   _non_class_space_arena = new MetaspaceArena(
-      non_class_cm,
+      non_class_context,
       ArenaGrowthPolicy::policy_for_space_type(space_type, false),
-      RunningCounters::used_nonclass_counter(),
-      "non-class sm");
+      Metaspace::min_allocation_alignment_words,
+      "non-class arena");
 
   // If needed, initialize class arena
-  if (Metaspace::using_class_space()) {
-    ChunkManager* const class_cm =
-            ChunkManager::chunkmanager_class();
+  if (class_context != nullptr) {
     _class_space_arena = new MetaspaceArena(
-        class_cm,
+        class_context,
         ArenaGrowthPolicy::policy_for_space_type(space_type, true),
-        RunningCounters::used_class_counter(),
-        "class sm");
+        klass_alignment_words,
+        "class arena");
   }
 
   UL2(debug, "born (nonclass arena: " PTR_FORMAT ", class arena: " PTR_FORMAT ".",
       p2i(_non_class_space_arena), p2i(_class_space_arena));
 }
@@ -87,16 +98,32 @@
 
 }
 
 // Allocate word_size words from Metaspace.
 MetaWord* ClassLoaderMetaspace::allocate(size_t word_size, Metaspace::MetadataType mdType) {
+  word_size = align_up(word_size, Metaspace::min_allocation_word_size);
   MutexLocker fcl(lock(), Mutex::_no_safepoint_check_flag);
-  if (Metaspace::is_class_space_allocation(mdType)) {
-    return class_space_arena()->allocate(word_size);
+  MetaBlock result, wastage;
+  const bool is_class = have_class_space_arena() && mdType == Metaspace::ClassType;
+  if (is_class) {
+    assert(word_size >= (sizeof(Klass)/BytesPerWord), "weird size for klass: %zu", word_size);
+    result = class_space_arena()->allocate(word_size, wastage);
   } else {
-    return non_class_space_arena()->allocate(word_size);
+    result = non_class_space_arena()->allocate(word_size, wastage);
+  }
+  if (wastage.is_nonempty()) {
+    non_class_space_arena()->deallocate(wastage);
+  }
+#ifdef ASSERT
+  if (result.is_nonempty()) {
+    const bool in_class_arena = class_space_arena() != nullptr ? class_space_arena()->contains(result) : false;
+    const bool in_nonclass_arena = non_class_space_arena()->contains(result);
+    assert((is_class && in_class_arena) || (!is_class && in_class_arena != in_nonclass_arena),
+           "block from neither arena " METABLOCKFORMAT "?", METABLOCKFORMATARGS(result));
   }
+#endif
+  return result.base();
 }
 
 // Attempt to expand the GC threshold to be good for at least another word_size words
 // and allocate. Returns null if failure. Used during Metaspace GC.
 MetaWord* ClassLoaderMetaspace::expand_and_allocate(size_t word_size, Metaspace::MetadataType mdType) {
@@ -129,17 +156,23 @@
 }
 
 // Prematurely returns a metaspace allocation to the _block_freelists
 // because it is not needed anymore.
 void ClassLoaderMetaspace::deallocate(MetaWord* ptr, size_t word_size, bool is_class) {
-  MutexLocker fcl(lock(), Mutex::_no_safepoint_check_flag);
-  if (Metaspace::using_class_space() && is_class) {
-    class_space_arena()->deallocate(ptr, word_size);
-  } else {
-    non_class_space_arena()->deallocate(ptr, word_size);
+  NOT_LP64(word_size = align_down(word_size, Metaspace::min_allocation_word_size);)
+  MetaBlock bl(ptr, word_size);
+  if (word_size >= Metaspace::min_allocation_word_size) {
+    MutexLocker fcl(lock(), Mutex::_no_safepoint_check_flag);
+    if (have_class_space_arena() && is_class) {
+      assert(class_space_arena()->contains(bl),
+             "Not from class arena " METABLOCKFORMAT "?", METABLOCKFORMATARGS(bl));
+      class_space_arena()->deallocate(MetaBlock(ptr, word_size));
+    } else {
+      non_class_space_arena()->deallocate(MetaBlock(ptr, word_size));
+    }
+    DEBUG_ONLY(InternalStats::inc_num_deallocs();)
   }
-  DEBUG_ONLY(InternalStats::inc_num_deallocs();)
 }
 
 // Update statistics. This walks all in-use chunks.
 void ClassLoaderMetaspace::add_to_statistics(metaspace::ClmsStats* out) const {
   MutexLocker fcl(lock(), Mutex::_no_safepoint_check_flag);
@@ -177,11 +210,11 @@
   size_t used_nc, comm_nc, cap_nc;
   size_t used_c = 0, comm_c = 0, cap_c = 0;
   {
     MutexLocker fcl(lock(), Mutex::_no_safepoint_check_flag);
     usage_numbers(Metaspace::MetadataType::NonClassType, &used_nc, &comm_nc, &cap_nc);
-    if (Metaspace::using_class_space()) {
+    if (have_class_space_arena()) {
       usage_numbers(Metaspace::MetadataType::ClassType, &used_c, &comm_c, &cap_c);
     }
   }
   if (p_used_words != nullptr) {
     (*p_used_words) = used_nc + used_c;
diff a/src/hotspot/share/memory/classLoaderMetaspace.hpp b/src/hotspot/share/memory/classLoaderMetaspace.hpp
--- a/src/hotspot/share/memory/classLoaderMetaspace.hpp
+++ b/src/hotspot/share/memory/classLoaderMetaspace.hpp
@@ -31,11 +31,13 @@
 
 class outputStream;
 
 namespace metaspace {
   struct ClmsStats;
+  class ClmsTester;
   class MetaspaceArena;
+  class MetaspaceContext;
 }
 
 // A ClassLoaderMetaspace manages MetaspaceArena(s) for a CLD.
 //
 // A CLD owns one MetaspaceArena if UseCompressedClassPointers is false. Otherwise
@@ -55,10 +57,11 @@
 //                                                  + chunk ... chunk
 //                                                               ^
 //                                                               alloc top
 //
 class ClassLoaderMetaspace : public CHeapObj<mtClass> {
+  friend class metaspace::ClmsTester; // for gtests
 
   // A reference to an outside lock, held by the CLD.
   Mutex* const _lock;
 
   const Metaspace::MetaspaceType _space_type;
@@ -73,12 +76,18 @@
 
   Mutex* lock() const                             { return _lock; }
   metaspace::MetaspaceArena* non_class_space_arena() const   { return _non_class_space_arena; }
   metaspace::MetaspaceArena* class_space_arena() const       { return _class_space_arena; }
 
-public:
+  bool have_class_space_arena() const { return _class_space_arena != nullptr; }
+
+  ClassLoaderMetaspace(Mutex* lock, Metaspace::MetaspaceType space_type,
+                       metaspace::MetaspaceContext* non_class_context,
+                       metaspace::MetaspaceContext* class_context,
+                       size_t klass_alignment_words);
 
+public:
   ClassLoaderMetaspace(Mutex* lock, Metaspace::MetaspaceType space_type);
 
   ~ClassLoaderMetaspace();
 
   Metaspace::MetaspaceType space_type() const { return _space_type; }
diff a/src/hotspot/share/memory/metaspace.cpp b/src/hotspot/share/memory/metaspace.cpp
--- a/src/hotspot/share/memory/metaspace.cpp
+++ b/src/hotspot/share/memory/metaspace.cpp
@@ -536,10 +536,12 @@
 }
 
 //////  Metaspace methods /////
 
 const MetaspaceTracer* Metaspace::_tracer = nullptr;
+const void* Metaspace::_class_space_start = nullptr;
+const void* Metaspace::_class_space_end = nullptr;
 
 bool Metaspace::initialized() {
   return metaspace::MetaspaceContext::context_nonclass() != nullptr
       LP64_ONLY(&& (using_class_space() ? Metaspace::class_space_is_initialized() : true));
 }
@@ -568,10 +570,12 @@
   assert(is_aligned(rs.base(), Metaspace::reserve_alignment()) &&
          is_aligned(rs.size(), Metaspace::reserve_alignment()),
          "wrong alignment");
 
   MetaspaceContext::initialize_class_space_context(rs);
+  _class_space_start = rs.base();
+  _class_space_end = rs.end();
 }
 
 // Returns true if class space has been setup (initialize_class_space).
 bool Metaspace::class_space_is_initialized() {
   return MetaspaceContext::context_class() != nullptr;
@@ -772,10 +776,11 @@
 
     // Initialize space
     Metaspace::initialize_class_space(rs);
 
     // Set up compressed class pointer encoding.
+    // In CDS=off mode, we give the JVM some leeway to choose a favorable base/shift combination.
     CompressedKlassPointers::initialize((address)rs.base(), rs.size());
   }
 
 #endif
 
@@ -840,13 +845,21 @@
 
   // Try to allocate metadata.
   MetaWord* result = loader_data->metaspace_non_null()->allocate(word_size, mdtype);
 
   if (result != nullptr) {
+#ifdef ASSERT
+    if (using_class_space() && mdtype == ClassType) {
+      assert(is_in_class_space(result) &&
+             is_aligned(result, CompressedKlassPointers::klass_alignment_in_bytes()), "Sanity");
+    } else {
+      assert((is_in_class_space(result) || is_in_nonclass_metaspace(result)) &&
+             is_aligned(result, Metaspace::min_allocation_alignment_bytes), "Sanity");
+    }
+#endif
     // Zero initialize.
     Copy::fill_to_words((HeapWord*)result, word_size, 0);
-
     log_trace(metaspace)("Metaspace::allocate: type %d return " PTR_FORMAT ".", (int)type, p2i(result));
   }
 
   return result;
 }
@@ -975,19 +988,15 @@
   // classes have been unloaded. However, this call is required for the code
   // in MetaspaceCriticalAllocation::try_allocate_critical to work.
   MetaspaceCriticalAllocation::process();
 }
 
-bool Metaspace::contains(const void* ptr) {
-  if (MetaspaceShared::is_in_shared_metaspace(ptr)) {
-    return true;
-  }
-  return contains_non_shared(ptr);
+// Returns true if pointer points into one of the metaspace regions, or
+// into the class space.
+bool Metaspace::is_in_shared_metaspace(const void* ptr) {
+  return MetaspaceShared::is_in_shared_metaspace(ptr);
 }
 
-bool Metaspace::contains_non_shared(const void* ptr) {
-  if (using_class_space() && VirtualSpaceList::vslist_class()->contains((MetaWord*)ptr)) {
-     return true;
-  }
-
+// Returns true if pointer points into one of the non-class-space metaspace regions.
+bool Metaspace::is_in_nonclass_metaspace(const void* ptr) {
   return VirtualSpaceList::vslist_nonclass()->contains((MetaWord*)ptr);
 }
diff a/src/hotspot/share/memory/metaspace.hpp b/src/hotspot/share/memory/metaspace.hpp
--- a/src/hotspot/share/memory/metaspace.hpp
+++ b/src/hotspot/share/memory/metaspace.hpp
@@ -24,20 +24,20 @@
  */
 #ifndef SHARE_MEMORY_METASPACE_HPP
 #define SHARE_MEMORY_METASPACE_HPP
 
 #include "memory/allocation.hpp"
+#include "memory/virtualspace.hpp"
 #include "runtime/globals.hpp"
 #include "utilities/exceptions.hpp"
 #include "utilities/globalDefinitions.hpp"
 
 class ClassLoaderData;
 class MetaspaceShared;
 class MetaspaceTracer;
 class Mutex;
 class outputStream;
-class ReservedSpace;
 
 ////////////////// Metaspace ///////////////////////
 
 // Namespace for important central static functions
 // (auxiliary stuff goes into MetaspaceUtils)
@@ -62,11 +62,13 @@
 
 private:
 
   static const MetaspaceTracer* _tracer;
 
-  static bool _initialized;
+  // For quick pointer testing: extent of class space; nullptr if no class space.
+  static const void* _class_space_start;
+  static const void* _class_space_end;
 
 public:
 
   static const MetaspaceTracer* tracer() { return _tracer; }
 
@@ -103,20 +105,53 @@
   static size_t commit_alignment_words();
 
   // The largest possible single allocation
   static size_t max_allocation_word_size();
 
+  // Minimum allocation alignment, in bytes. All MetaData shall be aligned correclty
+  // to be able to hold 64-bit data types. Unlike malloc, we don't care for larger
+  // data types.
+  static constexpr size_t min_allocation_alignment_bytes = sizeof(uint64_t);
+
+  // Minimum allocation alignment, in words, Metaspace observes.
+  static constexpr size_t min_allocation_alignment_words = min_allocation_alignment_bytes / BytesPerWord;
+
+  // Every allocation will get rounded up to the minimum word size.
+  static constexpr size_t min_allocation_word_size = min_allocation_alignment_words;
+
   static MetaWord* allocate(ClassLoaderData* loader_data, size_t word_size,
                             MetaspaceObj::Type type, TRAPS);
 
   // Non-TRAPS version of allocate which can be called by a non-Java thread, that returns
   // null on failure.
   static MetaWord* allocate(ClassLoaderData* loader_data, size_t word_size,
                             MetaspaceObj::Type type);
 
-  static bool contains(const void* ptr);
-  static bool contains_non_shared(const void* ptr);
+  static bool contains(const void* ptr) {
+    return is_in_shared_metaspace(ptr) || // in cds
+           is_in_class_space(ptr) ||      // in class space
+           is_in_nonclass_metaspace(ptr); // in one of the non-class regions?
+  }
+
+  // kept for now for backward compat reasons, but lets test if callers really need this
+  static bool contains_non_shared(const void* ptr) {
+    return is_in_class_space(ptr) ||      // in class space
+           is_in_nonclass_metaspace(ptr); // in one of the non-class regions?
+  }
+
+  // Returns true if pointer points into one of the metaspace regions, or
+  // into the class space.
+  static bool is_in_shared_metaspace(const void* ptr);
+
+  // Returns true if pointer points into one of the non-class-space metaspace regions.
+  static bool is_in_nonclass_metaspace(const void* ptr);
+
+  // Returns true if ptr points into class space, false if it doesn't or if
+  // there is no class space.
+  static inline bool is_in_class_space(const void* ptr) {
+    return ptr < _class_space_end && ptr >= _class_space_start;
+  }
 
   // Free empty virtualspaces
   static void purge(bool classes_unloaded);
 
   static void report_metadata_oome(ClassLoaderData* loader_data, size_t word_size,
diff a/src/hotspot/share/memory/metaspace/binList.hpp b/src/hotspot/share/memory/metaspace/binList.hpp
--- a/src/hotspot/share/memory/metaspace/binList.hpp
+++ b/src/hotspot/share/memory/metaspace/binList.hpp
@@ -26,20 +26,20 @@
 
 #ifndef SHARE_MEMORY_METASPACE_BINLIST_HPP
 #define SHARE_MEMORY_METASPACE_BINLIST_HPP
 
 #include "memory/metaspace/counters.hpp"
+#include "memory/metaspace/metablock.hpp"
 #include "memory/metaspace/metaspaceCommon.hpp"
 #include "utilities/align.hpp"
 #include "utilities/debug.hpp"
 #include "utilities/globalDefinitions.hpp"
 
 namespace metaspace {
 
 // BinList is a data structure to manage small to very small memory blocks
-// (only a few words). It is used to manage deallocated blocks - see
-// class FreeBlocks.
+// (only a few words). It is used to manage deallocated small blocks.
 
 // Memory blocks are kept in a vector of linked lists of equi-sized blocks:
 //
 // wordsize
 //
@@ -141,11 +141,14 @@
     for (int i = 0; i < num_lists; i++) {
       _blocks[i] = nullptr;
     }
   }
 
-  void add_block(MetaWord* p, size_t word_size) {
+  void add_block(MetaBlock mb) {
+    assert(!mb.is_empty(), "Don't add empty blocks");
+    const size_t word_size = mb.word_size();
+    MetaWord* const p = mb.base();
     assert(word_size >= MinWordSize &&
            word_size <= MaxWordSize, "bad block size");
     DEBUG_ONLY(write_canary(p, word_size);)
     const int index = index_for_word_size(word_size);
     Block* old_head = _blocks[index];
@@ -153,30 +156,28 @@
     _blocks[index] = new_head;
     _counter.add(word_size);
   }
 
   // Given a word_size, searches and returns a block of at least that size.
-  // Block may be larger. Real block size is returned in *p_real_word_size.
-  MetaWord* remove_block(size_t word_size, size_t* p_real_word_size) {
+  // Block may be larger.
+  MetaBlock remove_block(size_t word_size) {
     assert(word_size >= MinWordSize &&
            word_size <= MaxWordSize, "bad block size " SIZE_FORMAT ".", word_size);
+    MetaBlock result;
     int index = index_for_word_size(word_size);
     index = index_for_next_non_empty_list(index);
     if (index != -1) {
       Block* b = _blocks[index];
       const size_t real_word_size = word_size_for_index(index);
       assert(b != nullptr, "Sanity");
       assert(check_canary(b, real_word_size),
              "bad block in list[%d] (" BLOCK_FORMAT ")", index, BLOCK_FORMAT_ARGS(b, real_word_size));
       _blocks[index] = b->_next;
       _counter.sub(real_word_size);
-      *p_real_word_size = real_word_size;
-      return (MetaWord*)b;
-    } else {
-      *p_real_word_size = 0;
-      return nullptr;
+      result = MetaBlock((MetaWord*)b, real_word_size);
     }
+    return result;
   }
 
   // Returns number of blocks in this structure
   unsigned count() const { return _counter.count(); }
 
@@ -189,14 +190,18 @@
   void verify() const {
     MemRangeCounter local_counter;
     for (int i = 0; i < num_lists; i++) {
       const size_t s = word_size_for_index(i);
       int pos = 0;
+      Block* b_last = nullptr; // catch simple circularities
       for (Block* b = _blocks[i]; b != nullptr; b = b->_next, pos++) {
         assert(check_canary(b, s), "");
+        assert(b != b_last, "Circle");
         local_counter.add(s);
+        b_last = b;
       }
+      if (UseNewCode)printf("\n");
     }
     local_counter.check(_counter);
   }
 #endif // ASSERT
 
diff a/src/hotspot/share/memory/metaspace/blockTree.cpp b/src/hotspot/share/memory/metaspace/blockTree.cpp
--- a/src/hotspot/share/memory/metaspace/blockTree.cpp
+++ b/src/hotspot/share/memory/metaspace/blockTree.cpp
@@ -180,12 +180,12 @@
   _counter.check(counter);
 
   #undef assrt0n
 }
 
-void BlockTree::zap_range(MetaWord* p, size_t word_size) {
-  memset(p, 0xF3, word_size * sizeof(MetaWord));
+void BlockTree::zap_block(MetaBlock bl) {
+  memset(bl.base(), 0xF3, bl.word_size() * sizeof(MetaWord));
 }
 
 void BlockTree::print_tree(outputStream* st) const {
 
   // Note: we do not print the tree indented, since I found that printing it
@@ -224,10 +224,16 @@
           st->print_cr("@" PTR_FORMAT ": unreadable (skipping rest of chain).", p2i(n2));
           break; // stop printing this chain.
         }
       }
 
+      // Handle simple circularities
+      if (n == n->_right || n == n->_left || n == n->_next) {
+        st->print_cr("@" PTR_FORMAT ": circularity detected.", p2i(n));
+        return; // stop printing
+      }
+
       // Handle children.
       if (n->_right != nullptr) {
         walkinfo info2;
         info2.n = n->_right;
         info2.depth = info.depth + 1;
diff a/src/hotspot/share/memory/metaspace/blockTree.hpp b/src/hotspot/share/memory/metaspace/blockTree.hpp
--- a/src/hotspot/share/memory/metaspace/blockTree.hpp
+++ b/src/hotspot/share/memory/metaspace/blockTree.hpp
@@ -27,17 +27,18 @@
 #define SHARE_MEMORY_METASPACE_BLOCKTREE_HPP
 
 #include "memory/allocation.hpp"
 #include "memory/metaspace/chunklevel.hpp"
 #include "memory/metaspace/counters.hpp"
+#include "memory/metaspace/metablock.hpp"
 #include "utilities/debug.hpp"
 #include "utilities/globalDefinitions.hpp"
 
 namespace metaspace {
 
 // BlockTree is a rather simple binary search tree. It is used to
-//  manage small to medium free memory blocks (see class FreeBlocks).
+//  manage medium to large free memory blocks.
 //
 // There is no separation between payload (managed blocks) and nodes: the
 //  memory blocks themselves are the nodes, with the block size being the key.
 //
 // We store node pointer information in these blocks when storing them. That
@@ -78,12 +79,11 @@
 
     static const intptr_t _canary_value =
         NOT_LP64(0x4e4f4445) LP64_ONLY(0x4e4f44454e4f4445ULL); // "NODE" resp "NODENODE"
 
     // Note: we afford us the luxury of an always-there canary value.
-    //  The space for that is there (these nodes are only used to manage larger blocks,
-    //  see FreeBlocks::MaxSmallBlocksWordSize).
+    //  The space for that is there (these nodes are only used to manage larger blocks).
     //  It is initialized in debug and release, but only automatically tested
     //  in debug.
     const intptr_t _canary;
 
     // Normal tree node stuff...
@@ -333,38 +333,39 @@
       }
     }
   }
 
 #ifdef ASSERT
-  void zap_range(MetaWord* p, size_t word_size);
+  void zap_block(MetaBlock block);
   // Helper for verify()
   void verify_node_pointer(const Node* n) const;
 #endif // ASSERT
 
 public:
 
   BlockTree() : _root(nullptr) {}
 
   // Add a memory block to the tree. Its content will be overwritten.
-  void add_block(MetaWord* p, size_t word_size) {
-    DEBUG_ONLY(zap_range(p, word_size));
+  void add_block(MetaBlock block) {
+    DEBUG_ONLY(zap_block(block);)
+    const size_t word_size = block.word_size();
     assert(word_size >= MinWordSize, "invalid block size " SIZE_FORMAT, word_size);
-    Node* n = new(p) Node(word_size);
+    Node* n = new(block.base()) Node(word_size);
     if (_root == nullptr) {
       _root = n;
     } else {
       insert(_root, n);
     }
     _counter.add(word_size);
   }
 
   // Given a word_size, search and return the smallest block that is equal or
-  //  larger than that size. Upon return, *p_real_word_size contains the actual
-  //  block size.
-  MetaWord* remove_block(size_t word_size, size_t* p_real_word_size) {
+  //  larger than that size.
+  MetaBlock remove_block(size_t word_size) {
     assert(word_size >= MinWordSize, "invalid block size " SIZE_FORMAT, word_size);
 
+    MetaBlock result;
     Node* n = find_closest_fit(word_size);
 
     if (n != nullptr) {
       DEBUG_ONLY(check_node(n);)
       assert(n->_word_size >= word_size, "sanity");
@@ -377,19 +378,17 @@
         n = remove_from_list(n);
       } else {
         remove_node_from_tree(n);
       }
 
-      MetaWord* p = (MetaWord*)n;
-      *p_real_word_size = n->_word_size;
+      result = MetaBlock((MetaWord*)n, n->_word_size);
 
       _counter.sub(n->_word_size);
 
-      DEBUG_ONLY(zap_range(p, n->_word_size));
-      return p;
+      DEBUG_ONLY(zap_block(result);)
     }
-    return nullptr;
+    return result;
   }
 
   // Returns number of blocks in this structure
   unsigned count() const { return _counter.count(); }
 
diff a/src/hotspot/share/memory/metaspace/freeBlocks.cpp b/src/hotspot/share/memory/metaspace/freeBlocks.cpp
--- a/src/hotspot/share/memory/metaspace/freeBlocks.cpp
+++ b/src/hotspot/share/memory/metaspace/freeBlocks.cpp
@@ -28,34 +28,25 @@
 #include "utilities/debug.hpp"
 #include "utilities/globalDefinitions.hpp"
 
 namespace metaspace {
 
-void FreeBlocks::add_block(MetaWord* p, size_t word_size) {
-  if (word_size > MaxSmallBlocksWordSize) {
-    _tree.add_block(p, word_size);
+void FreeBlocks::add_block(MetaBlock bl) {
+  if (bl.word_size() > _small_blocks.MaxWordSize) {
+    _tree.add_block(bl);
   } else {
-    _small_blocks.add_block(p, word_size);
+    _small_blocks.add_block(bl);
   }
 }
 
-MetaWord* FreeBlocks::remove_block(size_t requested_word_size) {
+MetaBlock FreeBlocks::remove_block(size_t requested_word_size) {
   size_t real_size = 0;
-  MetaWord* p = nullptr;
-  if (requested_word_size > MaxSmallBlocksWordSize) {
-    p = _tree.remove_block(requested_word_size, &real_size);
+  MetaBlock bl;
+  if (requested_word_size > _small_blocks.MaxWordSize) {
+    bl = _tree.remove_block(requested_word_size);
   } else {
-    p = _small_blocks.remove_block(requested_word_size, &real_size);
+    bl = _small_blocks.remove_block(requested_word_size);
   }
-  if (p != nullptr) {
-    // Blocks which are larger than a certain threshold are split and
-    //  the remainder is handed back to the manager.
-    const size_t waste = real_size - requested_word_size;
-    if (waste >= MinWordSize) {
-      add_block(p + requested_word_size, waste);
-    }
-  }
-  return p;
+  return bl;
 }
 
 } // namespace metaspace
-
diff a/src/hotspot/share/memory/metaspace/freeBlocks.hpp b/src/hotspot/share/memory/metaspace/freeBlocks.hpp
--- a/src/hotspot/share/memory/metaspace/freeBlocks.hpp
+++ b/src/hotspot/share/memory/metaspace/freeBlocks.hpp
@@ -71,24 +71,20 @@
 
   // This verifies that blocks too large to go into the binlist can be
   // kept in the blocktree.
   STATIC_ASSERT(BinList32::MaxWordSize >= BlockTree::MinWordSize);
 
-  // Cutoff point: blocks larger than this size are kept in the
-  // tree, blocks smaller than or equal to this size in the bin list.
-  const size_t MaxSmallBlocksWordSize = BinList32::MaxWordSize;
-
 public:
 
   // Smallest blocks we can keep in this structure.
   const static size_t MinWordSize = BinList32::MinWordSize;
 
   // Add a block to the deallocation management.
-  void add_block(MetaWord* p, size_t word_size);
+  void add_block(MetaBlock bl);
 
-  // Retrieve a block of at least requested_word_size.
-  MetaWord* remove_block(size_t requested_word_size);
+  // Retrieve a block of at least requested_word_size. May be larger.
+  MetaBlock remove_block(size_t requested_word_size);
 
 #ifdef ASSERT
   void verify() const {
     _tree.verify();
     _small_blocks.verify();
diff a/src/hotspot/share/memory/metaspace/metablock.hpp b/src/hotspot/share/memory/metaspace/metablock.hpp
--- /dev/null
+++ b/src/hotspot/share/memory/metaspace/metablock.hpp
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2023 Red Hat, Inc. All rights reserved.
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#ifndef SHARE_MEMORY_METASPACE_METABLOCK_HPP
+#define SHARE_MEMORY_METASPACE_METABLOCK_HPP
+
+#include "utilities/globalDefinitions.hpp"
+
+class outputStream;
+
+namespace metaspace {
+
+// Tiny structure to be passed by value
+class MetaBlock {
+
+  MetaWord* _base;
+  size_t _word_size;
+
+public:
+
+  MetaBlock(MetaWord* p, size_t word_size) :
+    _base(word_size == 0 ? nullptr : p), _word_size(word_size) {}
+  MetaBlock() : MetaBlock(nullptr, 0) {}
+
+  MetaWord* base() const { return _base; }
+  const MetaWord* end() const { return _base + _word_size; }
+  size_t word_size() const { return _word_size; }
+  bool is_empty() const { return _base == nullptr; }
+  bool is_nonempty() const { return _base != nullptr; }
+  void reset() { _base = nullptr; _word_size = 0; }
+
+  bool operator==(const MetaBlock& rhs) const {
+    return base() == rhs.base() &&
+           word_size() == rhs.word_size();
+  }
+
+  // Split off tail block.
+  inline MetaBlock split_off_tail(size_t tailsize);
+
+  DEBUG_ONLY(inline void verify() const;)
+
+  // Convenience functions
+  inline bool is_aligned_base(size_t alignment_words) const;
+  inline bool is_aligned_size(size_t alignment_words) const;
+
+  void print_on(outputStream* st) const;
+};
+
+#define METABLOCKFORMAT                 "block (@" PTR_FORMAT " word size " SIZE_FORMAT ")"
+#define METABLOCKFORMATARGS(__block__)  p2i((__block__).base()), (__block__).word_size()
+
+} // namespace metaspace
+
+#endif // SHARE_MEMORY_METASPACE_METABLOCK_HPP
